from collections import defaultdict
import random
from tqdm import tqdm


def anchor_based_random_walks_forest_fire(_G, _anchor_nodes, num_walks, walk_length):
    rd_walks = []

    for count, anchor in tqdm(enumerate(_anchor_nodes)):

        if _G.degree(anchor) == 0:
            continue
        for i in range(num_walks):
            curr_node = anchor
            this_walk = [anchor]

            for j in range(walk_length):
                nbr = _G.neighbors(curr_node)
                nbr = list(filter(lambda a: a not in this_walk, nbr))
                if not nbr:
                    this_walk = sorted(this_walk)
                    if this_walk != [anchor] and this_walk not in rd_walks:
                        rd_walks.append(this_walk)
                    # running out of neighbors
                    break

                next_node = random.choice(nbr)

                this_walk.append(next_node)
                _G.remove_edge(curr_node, next_node)
                curr_node = next_node

                if j == walk_length - 1:
                    this_walk = sorted(this_walk)
                    if this_walk not in rd_walks:
                        rd_walks.append(this_walk)

    print('> Get', len(rd_walks), 'random walks. ')
    return rd_walks


def create_dicts(fn, l_g):
    dict_tf_target = defaultdict(list)
    with open(fn, 'r') as f:
        for cnt_line, line in tqdm(enumerate(f)):
            if cnt_line == 0:
                continue
            else:
                TF, target = line.strip('\n').split('\t')
                TF = TF
                target = target

                if TF in l_g and target in l_g:
                    dict_tf_target[TF].append(target)

    return dict_tf_target


def read_anchor(fn):
    anchor = set()
    with open(fn, 'r') as f:
        for line in f:
            anchor.add(line.strip('\n'))
    return anchor
